#ifndef __APPWINDOW_H__
#define __APPWINDOW_H__

#include <windows.h>
#include <imaging.h>


class CAppWindow
{
public:
    CAppWindow();
    ~CAppWindow();

    HRESULT CreateControls( HINSTANCE hInstance );
    HRESULT Run();

private:

	static const int MAX_MESSAGE_LENGTH = 64;

    HWND    m_hwnd;
    HWND    m_button;
    WCHAR   m_wzStatusString[MAX_MESSAGE_LENGTH];

    //CGraphManager *m_pGraphManager;

    static LRESULT CALLBACK AppWindowProc( HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam ); 
    LRESULT HandleWindowProc( HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam );
	HRESULT HandleCommand( WPARAM wParam );
    HRESULT RepaintWindow();
    void    UpdateMessage( WCHAR *message );

	int current_cursor_x;
	int current_cursor_y;

	int target_cursor_x;
	int target_cursor_y;

	int clean_background;

	//Imaging related declerations
	IImagingFactory*	pImgFactory;
	IImage*				pImage;
	//RECT				rc_wnd;
	int					mSclFac,mSclFacMax,mSclFacMin;	//Scale Factor for zooming
};



#endif