#include "VideoCap.h"
#include "Bitmap.h"

#include "hbma.h"
#include "CImg.h"
using namespace cimg_library;

#define WRITE_ALL_FRAMES 0
#define APPLY_CONFIDENCE 0

#define cliptop(x) (x>255 ? 255:x)
#define clipbottom(x) (x<0 ? 0:x)
#define clip(x) (clipbottom(cliptop(x)))

int count=0;

extern int g_deltaX;
extern int g_deltaY;
extern int g_ID;

//the variables used to smooth the trajectory
//TODO: would be placed better
int tResultMotionX = 0;
int tResultMotionY = 0;

/*
void Convert_YV12_to_RGB24(BYTE *YV12, BitmapLite *frame)
{
	int width=frame->get_width();
	int height=frame->get_height();

	int YArraySize = height * width;
	for (int y=0; y<height; y++)
		for (int x=0; x<width; x++)
		{
			int Y = YV12[y * width + x];
			int V = YV12[(y/2) * (width/2) + x/2 + YArraySize];
			int U = YV12[(y/2) * (width/2) + x/2 + YArraySize + YArraySize/4];

			int C = Y - 16;
			int D = U - 128;
			int E = V - 128;

			unsigned char R = clip(( 298 * C           + 409 * E + 128) >> 8);
			unsigned char G = clip(( 298 * C - 100 * D - 208 * E + 128) >> 8);
			unsigned char B = clip(( 298 * C + 516 * D           + 128) >> 8);

			//int index=x+(height-y-1)*width;
			int index=x+y*width;

			frame->buffer[index].color.set_r(R);
			frame->buffer[index].color.set_g(G);
			frame->buffer[index].color.set_b(B);
		}
}

void ProcessFrame ( BitmapLite *frame )
{
	Convert_YV12_to_RGB24(frame->yuvP,frame);

	//change color of few pixels for testing
	frame->buffer[10+10*176].color.set_r(0);
	frame->buffer[10+10*176].color.set_g(255);
	frame->buffer[10+10*176].color.set_b(0);

	frame->buffer[11+10*176].color.set_r(255);
	frame->buffer[11+10*176].color.set_g(0);
	frame->buffer[11+10*176].color.set_b(0);

	if (WRITE_ALL_FRAMES)
	{
		count ++;
		char filename[100];
		sprintf(filename, "\\temp\\frame%d.bmp", count);
		//if (count ==10)
			//frame->write(filename);
	}

	//caglayan compute and write g_deltaX etc here
	g_deltaX=0;
	//g_deltaY=0;

	//assign a new id by incrementing id for each instance
	g_ID++;

	//caglayan, give burcu also your recognition results so that she can produce commands.
}
*/

void ProcessFrame ( CImg<BYTE> &cAnchorIm, CImg<BYTE> &cTargetIm  )
{
	//Parameters
	const int kBlockSize		= 9;
	const int kRadius			= 16;
	const int kLevel			= 3;
	const int kCutBlock			= 1;
	const int kMagnifyFactor	= 20;
	const int kResizeFactor		= 8;
	
	//Process the frame
	long tTotalMotionX,tTotalMotionY;
	//Apply motion estimation
	CImg<int> tMotion = CImg<int>(applyHBMA(cAnchorIm, cTargetIm, kBlockSize, kRadius, kLevel));
	//CImg<int> tMotion = CImg<int>(15,15,1,1,0);
	//tMotion.crop(1,1,tMotion.width-1,tMotion.height-1);

	if(APPLY_CONFIDENCE){
		//Calculate xy reliability of the image blocks
		CImg<int> tConfidence = CImg<int>(blockConfidence(cTargetIm,kBlockSize));
		const int kThresh = kBlockSize*kBlockSize/2;
		tConfidence.threshold(kThresh);
		//Take weighted average with the motion
		tMotion.mul(tConfidence);

		tTotalMotionX = CImg<int>(tMotion).channel(0).sum()/(tConfidence.sum()+1)*kMagnifyFactor;
		tTotalMotionY = CImg<int>(tMotion).channel(1).sum()/(tConfidence.sum()+1)*kMagnifyFactor;
	}
	else{
		tTotalMotionX = (long)(CImg<long>(tMotion).channel(0).sum());
		tTotalMotionY = (long)(CImg<long>(tMotion).channel(1).sum());

		tTotalMotionX *= kMagnifyFactor;
		tTotalMotionY *= kMagnifyFactor;

		tTotalMotionX /= (long)tMotion.width*(long)tMotion.height;
		tTotalMotionY /= (long)tMotion.width*(long)tMotion.height;
	}

	tTotalMotionX = -tTotalMotionX;
	tTotalMotionY = -tTotalMotionY;

	tResultMotionX = (10*tResultMotionX + 10*tTotalMotionX)/20;
	tResultMotionY = (10*tResultMotionY + 10*tTotalMotionY)/20;
	
	//long tTotalMotionX,tTotalMotionY;
	//tTotalMotionX = CImg<int>(tMotion).channel(0).sum()/(kBlockSize*kBlockSize)*kMagnifyFactor;
	//tTotalMotionY = CImg<int>(tMotion).channel(1).sum()/(kBlockSize*kBlockSize)*kMagnifyFactor;

	//take the negative of the motion vectors!!!
	//tTotalMotionX = -tTotalMotionX;
	//tTotalMotionY = -tTotalMotionY;

	
	//long bIsMoving = CImg<int>(tMotion).abs().sum();
	if(WRITE_ALL_FRAMES){
		char tFileName[100];
		sprintf(tFileName,"\\temp\\frame%d.bmp",count++);
		cTargetIm.save_bmp(tFileName);
	}

	//cin.get();
	
	cerr<<" dx:"<<tResultMotionX<<" dy:"<<tResultMotionY<<endl;
	//cout.flush();

	

	g_deltaX = tResultMotionX;
	g_deltaY = tResultMotionY;
	g_ID++;
}

