
#include <streams.h>
#include <initguid.h>
#include "VideoCapFilter.h"
#include "VideoCap.h"
#include "IVideoCapMobileFilter_i.c"
#include "..\\commands.h"

int g_deltaX; //really ugly code :(
int g_deltaY;
int g_ID;

const AMOVIESETUP_MEDIATYPE VideoCapFilter_media_type =
{
    &MEDIATYPE_Video,       // Major type
    &MEDIASUBTYPE_NULL      // Minor type
};

const AMOVIESETUP_PIN VideoCapFilter_pins[] =
{
    { L"Input",							// Pins string name
      FALSE,							// Is it rendered
      FALSE,							// Is it an output
      FALSE,							// Are we allowed none
      FALSE,							// And allowed many
      &CLSID_NULL,						// Connects to filter
      NULL,								// Connects to pin
      1,								// Number of types
      &VideoCapFilter_media_type	// Pin information
    },
    { L"Output",						// Pins string name
      FALSE,							// Is it rendered
      TRUE,								// Is it an output
      FALSE,							// Are we allowed none
      FALSE,							// And allowed many
      &CLSID_NULL,						// Connects to filter
      NULL,								// Connects to pin
      1,								// Number of types
      &VideoCapFilter_media_type	// Pin information
    }
};

const AMOVIESETUP_FILTER VideoCapFilter_data =
{
    &CLSID_VideoCapFilter,	// Filter CLSID
    L"VideoCapFilter",		// String name
    MERIT_DO_NOT_USE,				// Filter merit
    2,								// Number of pins
    VideoCapFilter_pins		// Pin information
};


// List of class IDs and creator functions for the class factory. This
// provides the link between the OLE entry point in the DLL and an object
// being created. The class factory will call the static CreateInstance

CFactoryTemplate g_Templates[] = {
    { L"VideoCapFilter"
    , &CLSID_VideoCapFilter
    , VideoCapFilter::CreateInstance
    , NULL
    , &VideoCapFilter_data }
};

int g_cTemplates = sizeof(g_Templates) / sizeof(g_Templates[0]);

////
//// DllRegisterServer
////
//// Handles sample registry and unregistry
////
STDAPI DllRegisterServer()
{
    return AMovieDllRegisterServer();

} // DllRegisterServer


//
// DllUnregisterServer
//
STDAPI DllUnregisterServer()
{
    return AMovieDllUnregisterServer();

} // DllUnregisterServer


//================================================================================
// Purpose: DLL Exported functions to enable registration via regsvr32.exe
// Access:  Public/Exported
//================================================================================
extern "C" BOOL WINAPI DllEntryPoint(HINSTANCE, ULONG, LPVOID); 

//STDAPI DllRegisterServer() 
//{ 
//	return AMovieDllRegisterServer2( TRUE ); 
//} 
//
//STDAPI DllUnregisterServer() 
//{ 
//	return AMovieDllRegisterServer2( FALSE ); 
//} 

BOOL APIENTRY DllMain(HANDLE hModule, DWORD  dwReason, LPVOID lpReserved) 
{ 
	return DllEntryPoint((HINSTANCE)(hModule), dwReason, lpReserved); 
} 





VideoCapFilter::VideoCapFilter (TCHAR *tszName, LPUNKNOWN punk, HRESULT *phr)
: CVideoTransformFilter( tszName, punk, CLSID_VideoCapFilter )
{
	
	//frame = new BitmapLite(176,144);
	g_deltaX=0;
	g_deltaY=0;
	g_ID=0;
}


VideoCapFilter::~VideoCapFilter( void )
{
	//delete frame;
}


CUnknown * WINAPI VideoCapFilter::CreateInstance(LPUNKNOWN punk, HRESULT *phr)
{
    VideoCapFilter *pNewObject = 
		new VideoCapFilter( L"VideoCapFilter", punk, phr);

	if (pNewObject == NULL) {
        *phr = E_OUTOFMEMORY;
    }

	return pNewObject;
}


HRESULT VideoCapFilter::Transform(IMediaSample *pIn, IMediaSample *pOut)
{
    // Copy the properties across

    HRESULT hr = Copy(pIn, pOut);
    if (FAILED(hr)) {
        return hr;
    }

	Transform(pOut);

    //// Check to see if it is time to do the sample

    //CRefTime tStart, tStop ;
    //pIn->GetTime((REFERENCE_TIME *) &tStart, (REFERENCE_TIME *) &tStop);

    //if (tStart >= m_effectStartTime) {
    //    if (tStop <= (m_effectStartTime + m_effectTime)) {
    //        return Transform(pOut);
    //    }
    //}
    return NOERROR;

}


HRESULT VideoCapFilter::CheckInputType(const CMediaType *mtIn)
{
    // check this is a VIDEOINFOHEADER type

    if (*mtIn->FormatType() != FORMAT_VideoInfo) {
        return E_INVALIDARG;
    }

    //// Can we transform this type

    if (CanPerformVideoCapFilter(mtIn)) {
    	return NOERROR;
    }
    return E_FAIL;
}


HRESULT VideoCapFilter::CheckTransform(const CMediaType *mtIn, const CMediaType *mtOut)
{
    if (CanPerformVideoCapFilter(mtIn)) {
        if (*mtIn == *mtOut) {
            return NOERROR;
        }
    }
    return E_FAIL;
}


HRESULT VideoCapFilter::DecideBufferSize(IMemAllocator *pAlloc, ALLOCATOR_PROPERTIES *pProperties)
{
    // Is the input pin connected

    if (m_pInput->IsConnected() == FALSE) {
        return E_UNEXPECTED;
    }

    ASSERT(pAlloc);
    ASSERT(pProperties);
    HRESULT hr = NOERROR;

    pProperties->cBuffers = 1;
    pProperties->cbBuffer = m_pInput->CurrentMediaType().GetSampleSize();
    ASSERT(pProperties->cbBuffer);

    // Ask the allocator to reserve us some sample memory, NOTE the function
    // can succeed (that is return NOERROR) but still not have allocated the
    // memory that we requested, so we must check we got whatever we wanted

    ALLOCATOR_PROPERTIES Actual;
    hr = pAlloc->SetProperties(pProperties,&Actual);
    if (FAILED(hr)) {
        return hr;
    }

    ASSERT( Actual.cBuffers == 1 );

    if (pProperties->cBuffers > Actual.cBuffers ||
            pProperties->cbBuffer > Actual.cbBuffer) {
                return E_FAIL;
    }
    return NOERROR;
}


HRESULT VideoCapFilter::GetMediaType(int iPosition, CMediaType *pMediaType)
{
    // Is the input pin connected

    if (m_pInput->IsConnected() == FALSE) {
        return E_UNEXPECTED;
    }

    // This should never happen

    if (iPosition < 0) {
        return E_INVALIDARG;
    }

    // Do we have more items to offer

    if (iPosition > 0) {
        return VFW_S_NO_MORE_ITEMS;
    }

    *pMediaType = m_pInput->CurrentMediaType();
    return NOERROR;
}


HRESULT VideoCapFilter::Copy(IMediaSample *pSource, IMediaSample *pDest) const
{
    // Copy the sample data

    BYTE *pSourceBuffer, *pDestBuffer;
    long lSourceSize = pSource->GetActualDataLength();

#ifdef DEBUG
    long lDestSize	= pDest->GetSize();
    ASSERT(lDestSize >= lSourceSize);
#endif

    pSource->GetPointer(&pSourceBuffer);
    pDest->GetPointer(&pDestBuffer);

    CopyMemory( (PVOID) pDestBuffer,(PVOID) pSourceBuffer,lSourceSize);

    // Copy the sample times

    REFERENCE_TIME TimeStart, TimeEnd;
    if (NOERROR == pSource->GetTime(&TimeStart, &TimeEnd)) {
        pDest->SetTime(&TimeStart, &TimeEnd);
    }

    LONGLONG MediaStart, MediaEnd;
    if (pSource->GetMediaTime(&MediaStart,&MediaEnd) == NOERROR) {
        pDest->SetMediaTime(&MediaStart,&MediaEnd);
    }

    // Copy the Sync point property

    HRESULT hr = pSource->IsSyncPoint();
    if (hr == S_OK) {
        pDest->SetSyncPoint(TRUE);
    }
    else if (hr == S_FALSE) {
        pDest->SetSyncPoint(FALSE);
    }
    else {  // an unexpected error has occured...
        return E_UNEXPECTED;
    }

    // Copy the media type

    AM_MEDIA_TYPE *pMediaType;
    pSource->GetMediaType(&pMediaType);
    pDest->SetMediaType(pMediaType);
    DeleteMediaType(pMediaType);

    // Copy the preroll property

    hr = pSource->IsPreroll();
    if (hr == S_OK) {
        pDest->SetPreroll(TRUE);
    }
    else if (hr == S_FALSE) {
        pDest->SetPreroll(FALSE);
    }
    else {  // an unexpected error has occured...
        return E_UNEXPECTED;
    }

    // Copy the discontinuity property

    hr = pSource->IsDiscontinuity();
    if (hr == S_OK) {
	pDest->SetDiscontinuity(TRUE);
    }
    else if (hr == S_FALSE) {
        pDest->SetDiscontinuity(FALSE);
    }
    else {  // an unexpected error has occured...
        return E_UNEXPECTED;
    }

    // Copy the actual data length

    long lDataLength = pSource->GetActualDataLength();
    pDest->SetActualDataLength(lDataLength);

    return NOERROR;

} // Copy


HRESULT VideoCapFilter::Transform(IMediaSample *pMediaSample)
{
	UpdateFrame( pMediaSample );
	if(gAnchorFrame.size() > 0 && gTargetFrame.size() > 0){
		ProcessFrame(gAnchorFrame,gTargetFrame);		
	}	
	gAnchorFrame = gTargetFrame;
	Sleep(100);
	//ProcessFrame( frame );
	

	return NOERROR;
}

//
// CanPerformEZrgb24
//
// Check if this is a RGB24 true colour format
//
BOOL VideoCapFilter::CanPerformVideoCapFilter(const CMediaType *pMediaType) const
{
	const GUID *type    = pMediaType->Type();
	const GUID *subtype = pMediaType->Subtype();

    if (IsEqualGUID(*pMediaType->Type(), MEDIATYPE_Video)) {
		//if (IsEqualGUID(*pMediaType->Subtype(), MEDIASUBTYPE_RGB24)) {
          //  VIDEOINFOHEADER *pvi = (VIDEOINFOHEADER *) pMediaType->Format();
            //return (pvi->bmiHeader.biBitCount == 24);
//        }
		if (IsEqualGUID(*pMediaType->Subtype(), MEDIASUBTYPE_YV12)) {
            return TRUE;
        }
    }
    return FALSE;

} // CanPerformEZrgb24


LPAMOVIESETUP_FILTER VideoCapFilter::GetSetupData()
{
	return (LPAMOVIESETUP_FILTER) &VideoCapFilter_data ;
}


void VideoCapFilter::UpdateFrame( IMediaSample *pMediaSample )
{
	AM_MEDIA_TYPE* pType = &m_pInput->CurrentMediaType();
    VIDEOINFOHEADER *pvi = (VIDEOINFOHEADER *) pType->pbFormat;

	////frame->set_width(  pvi->bmiHeader.biWidth );
	////frame->set_height( pvi->bmiHeader.biHeight );

	//frame->set_width(  176 );
 //   frame->set_height( 144 );

	BYTE *data;
	pMediaSample->GetPointer( &data );

	////frame->set_image_buffer( reinterpret_cast<BitmapLite::Pixel*>(data) );
	////frame->yuvP=data;

	//temporary image to for camera input
	CImg <BYTE> pInputImage = CImg<BYTE>(pvi->bmiHeader.biWidth,abs(pvi->bmiHeader.biHeight),1,1);
	pInputImage.assign(data,pvi->bmiHeader.biWidth,abs(pvi->bmiHeader.biHeight),1,1);
	gTargetFrame = pInputImage;
	gTargetFrame.crop(16,0,159,143);
	/*
	//resize the image
	gTargetFrame.assign(pvi->bmiHeader.biWidth,abs(pvi->bmiHeader.biHeight),1,1);
	//assign the Y data of the frame
	gTargetFrame.assign(data,pvi->bmiHeader.biWidth,abs(pvi->bmiHeader.biHeight),1,1);
	//resize the image
	//gTargetFrame.crop(16,159,0,143);
	*/
}


//================================================================================
// Purpose: Support both nondelegating and delegating IUnknown interfaces 
//			in the same COM object
// Access:  Public
// Declared in: INonDelegatingUnknown
//================================================================================
HRESULT VideoCapFilter::NonDelegatingQueryInterface(REFIID riid, void **ppv)
{
    CheckPointer(ppv,E_POINTER);

    if (riid == IID_IVideoCapMobileFilter) 
	{
        return GetInterface((IVideoCapMobileFilter *) this, ppv);
    }
    else 
	{
        return CTransformFilter::NonDelegatingQueryInterface(riid, ppv);
    }
}


HRESULT VideoCapFilter::get_RecognitionResults( int *deltax, int *deltay, int *id, int *command )
{
	//Caglayan, assign your computed results here that you get from ProcessFrame. 
	*deltax=g_deltaX;
	*deltay=g_deltaY;
	*id=g_ID;
	*command=SET_PEN_THICKNESS_TO_TWO;
    
    return S_OK;
}

HRESULT VideoCapFilter::set_Param( int param)
{
	int param1=param;
    return S_OK;
}
