#ifndef __VIDEOCAPFILTER_H__
#define __VIDEOCAPFILTER_H__


// {2B84DEF6-AB7C-4344-813F-4686E5081811}
DEFINE_GUID(CLSID_VideoCapFilter, 
 0xc6e83237, 0xd418, 0x4e5d, 0x95, 0xa9, 0xcd, 0xd9, 0x0, 0xb2, 0xec,0xfc );

#include <streams.h>
#include "Bitmap.h"
#include "IVideoCapMobileFilter_h.h"

#include "CImg.h"
using namespace cimg_library;

class VideoCapFilter 
	: public CVideoTransformFilter
	, public IVideoCapMobileFilter
{
public:

    DECLARE_IUNKNOWN;
    static CUnknown * WINAPI CreateInstance(LPUNKNOWN punk, HRESULT *phr);

    // Overrriden from CTransformFilter base class

    HRESULT Transform(IMediaSample *pIn, IMediaSample *pOut);
	//HRESULT GetVector(int *dx,int *dy, int *index);
    HRESULT CheckInputType(const CMediaType *mtIn);
    HRESULT CheckTransform(const CMediaType *mtIn, const CMediaType *mtOut);
    HRESULT DecideBufferSize(IMemAllocator *pAlloc,
			     ALLOCATOR_PROPERTIES *pProperties);
    HRESULT GetMediaType(int iPosition, CMediaType *pMediaType);

	// Declared in INonDelagatingUnknown
	STDMETHODIMP NonDelegatingQueryInterface(REFIID riid, void **ppv);

	// Declared in IVideoCapMobileFilter
    STDMETHODIMP get_RecognitionResults( int *deltax, int *deltay, int *id, int *command );
    STDMETHODIMP set_Param( int param);


private:

	//BitmapLite *frame;
	CImg<BYTE>	gTargetFrame;
	CImg<BYTE>	gAnchorFrame;

    VideoCapFilter (TCHAR *tszName, LPUNKNOWN punk, HRESULT *phr);
    ~VideoCapFilter( void );

    HRESULT Copy(IMediaSample *pSource, IMediaSample *pDest) const;
    HRESULT Transform(IMediaSample *pMediaSample);
	BOOL CanPerformVideoCapFilter(const CMediaType *pMediaType) const;
	virtual LPAMOVIESETUP_FILTER GetSetupData();

	void InitializeFrame ( void );
	void UpdateFrame( IMediaSample *pMediaSample );


};

#endif