// Copyright (c) Microsoft Corporation.  All rights reserved.
//
// Use of this source code is subject to the terms of the Microsoft end-user
// license agreement (EULA) under which you licensed this SOFTWARE PRODUCT.
// If you did not accept the terms of the EULA, you are not authorized to use
// this source code. For a copy of the EULA, please see the LICENSE.RTF on your
// install media.
// Imaging.cpp : Defines the entry point for the application.

#include "stdafx.h"
#include <windows.h>
#include <commctrl.h>
#include <imaging.h>
#include <initguid.h>
#include <imgguids.h>

#ifdef POCKETPC2003_UI_MODEL
#include "resourceppc.h"
#endif 
#ifdef SMARTPHONE2003_UI_MODEL
#include "resourcesp.h"
#endif

#define MAX_LOADSTRING 100

// Global Variables:
	HINSTANCE           g_hInst;            // current instance
	HWND                g_hWndMenuBar;        // menu bar handle
    IImagingFactory*	pImgFactory = NULL;
    IImage*				pImage = NULL;
    RECT				rc_img = { 0, 0, 2400, 2680};
    RECT				rc_wnd = { 0, 0, 110, 88};
	int					shift_x = 0;
	int					shift_y = 0;
	int					last_mouse_x = 0;
	int					last_mouse_y = 0;
	bool				drawing = false;
	int* FigCoorxPtr;
	int* FigCooryPtr;
	bool* FigCoordPtr;
	char* FigCoorcPtr;
	int* FigCoorwPtr;
	int width =5;
	char color='b';
  //  const char * cptr = &color;
	//char*& refptr = &cptr;
	
				 
	int max_shift=0;
	HPEN hPen;
	HWND hWnd;

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE, LPTSTR);
bool				InitInstance(HINSTANCE, int);
LRESULT CALLBACK    WndProc(HWND, UINT, WPARAM, LPARAM);
#ifndef WIN32_PLATFORM_WFSP
INT_PTR CALLBACK    About(HWND, UINT, WPARAM, LPARAM);
#endif // !WIN32_PLATFORM_WFSP

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
    MSG msg;
    // Perform application initialization:
    if (!InitInstance(hInstance, nCmdShow))  return false;

#ifndef WIN32_PLATFORM_WFSP
    HACCEL hAccelTable;
    hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_IMAGING));
#endif // !WIN32_PLATFORM_WFSP
/*
	SendMessage( 
  (HWND) hWnd,              // handle to destination window 
  WM_SETREDRAW,             // message to send
  (WPARAM) wParam,          // redraw state
  (LPARAM) lParam           // not used; must be zero
);
*/
    // Main message loop:
    while (GetMessage(&msg, NULL, 0, 0)) 
    {
#ifndef WIN32_PLATFORM_WFSP
       if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
#endif // !WIN32_PLATFORM_WFSP
        {
            TranslateMessage(&msg);DispatchMessage(&msg);
		}
    }

	if (pImage != NULL)   pImage->Release();
    if (pImgFactory != NULL)   pImgFactory->Release();
    CoUninitialize();
   
	free (FigCoorxPtr);
	free (FigCooryPtr);
	free (FigCoordPtr);
	free (FigCoorcPtr);
	free (FigCoorwPtr);
    return (int) msg.wParam;
}

//  FUNCTION: MyRegisterClass()
//  PURPOSE: Registers the window class.
//  COMMENTS:

ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szWindowClass)
{
    WNDCLASS wc;
    wc.style         = CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc   = WndProc;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = 0;
    wc.hInstance     = hInstance;
    wc.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_IMAGING));
    wc.hCursor       = 0;
    wc.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);
    wc.lpszMenuName  = 0;
    wc.lpszClassName = szWindowClass;

    return RegisterClass(&wc);
}

//   FUNCTION: InitInstance(HINSTANCE, int)
//   PURPOSE: Saves instance handle and creates main window
//   COMMENTS:
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
bool InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   // HWND hWnd;
    TCHAR szTitle[MAX_LOADSTRING];			// title bar text
    TCHAR szWindowClass[MAX_LOADSTRING];    // main window class name

	g_hInst = hInstance; // Store instance handle in our global variable
#ifdef WIN32_PLATFORM_PSPC
    // SHInitExtraControls should be called once during your application's initialization to initialize any
    // of the Pocket PC special controls such as CAPEDIT and SIPPREF.
    SHInitExtraControls();
#endif // WIN32_PLATFORM_PSPC
    LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING); 
    LoadString(hInstance, IDC_IMAGING, szWindowClass, MAX_LOADSTRING);
#if defined(WIN32_PLATFORM_PSPC) || defined(WIN32_PLATFORM_WFSP)
    //If it is already running, then focus on the window, and exit
    hWnd = FindWindow(szWindowClass, szTitle);    
    if (hWnd) 
    {
        // set focus to foremost child window
        // The "| 0x00000001" is used to bring any owned windows to the foreground and
        // activate them.
        SetForegroundWindow((HWND)((ULONG) hWnd | 0x00000001));
        return 0;
    } 
#endif // WIN32_PLATFORM_PSPC || WIN32_PLATFORM_WFSP
	if (!MyRegisterClass(hInstance, szWindowClass))   return false;
   	hWnd = CreateWindow(szWindowClass, szTitle, WS_VISIBLE,
        CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);
	if (!hWnd)  return false;
#ifdef WIN32_PLATFORM_PSPC
    // When the main window is created using CW_USEDEFAULT the height of the menubar (if one
    // is created is not taken into account). So we resize the window after creating it
    // if a menubar is present
    if (g_hWndMenuBar)
    {
        RECT rc;
        RECT rcMenuBar;

        GetWindowRect(hWnd, &rc);
        GetWindowRect(g_hWndMenuBar, &rcMenuBar);
        rc.bottom -= (rcMenuBar.bottom - rcMenuBar.top);
        
        MoveWindow(hWnd, rc.left, rc.top, rc.right-rc.left, rc.bottom-rc.top, false);
		rc_wnd = rc;
		rc_wnd.right -= rc_wnd.left;
		rc_wnd.left = 0;
		rc_wnd.bottom -= rc_wnd.top;
		rc_wnd.top = 0;
    }
#endif // WIN32_PLATFORM_PSPC

	// Normally you would only call CoInitialize/CoUninitialize
    // once per thread.  This sample calls CoInitialize in this
    // draw function simply to illustrate that you must call 
    // CoInitialize before calling CoCreateInstance.
    CoInitializeEx(NULL, COINIT_MULTITHREADED);

    // Create the imaging factory.
 /*   if (SUCCEEDED(CoCreateInstance (CLSID_ImagingFactory,
                                    NULL,
                                    CLSCTX_INPROC_SERVER,
                                    IID_IImagingFactory,
                                    (void **)&pImgFactory)))
    {
        // Load the image from the JPG file.
        //if (SUCCEEDED(
		pImgFactory->CreateImageFromFile(
		//TEXT("C:\\Users\\Milos\\Research\\Projekty\\eNTERFACE\\development\\Imaging\\Flower.jpg"),
										TEXT("\\Program Files\\Imaging\\map.jpg"), &pImage);//))
		//else	pImage = NULL;
	}

	*/
	// else pImgFactory = NULL;
	
    ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);
    return true;
}

//   FUNCTION:  DrawImage(HDC);
//   PURPOSE: Load an image from a file and draw it to the given HDC
/*
void DrawImage(HDC hdc)
{
	
	//	HPEN    hPenOld;
    // Draw the image.
	// if (pImage != NULL)
	//	pImage->Draw(hdc, &rc_wnd, &rc_img);
	//	hPen = CreatePen( PS_SOLID,PS_DASH,RGB(0,0,255));
    
	if(max_shift>1 && drawing ==true )
	{
		//hPen = CreatePen(PS_SOLID, 5, RGB(0, 0, 0));
		//hPenOld = (HPEN)SelectObject(hdc, hPen);
  		MoveToEx(hdc, FigCoorxPtr[0], FigCooryPtr[0],NULL );
	
		for(int i=1; i<max_shift; i++)
			if (FigCoordPtr[i]==true)
			{
				if ((FigCoorcPtr[i]!=FigCoorcPtr[i-1]) || (FigCoorwPtr[i]!=FigCoorwPtr[i-1])) 
				{
					DeleteObject(hPen);
					if (FigCoorcPtr[i]=='b')		hPen = CreatePen(PS_SOLID, FigCoorwPtr[i], RGB(0,0,0)); 
					else if (FigCoorcPtr[i]=='r')	hPen = CreatePen(PS_SOLID, FigCoorwPtr[i], RGB(255,0,0));
					//hPen = (HPEN)SelectObject(hdc, hPen); //
				}

				LineTo(hdc, FigCoorxPtr[i], FigCooryPtr[i]);
	}
			else	MoveToEx(hdc, FigCoorxPtr[i], FigCooryPtr[i],NULL );
	//	SelectObject(hdc, hPenOld);
	DeleteObject(hPen);
	} 
}*/

//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//  PURPOSE:  Processes messages for the main window.
//  WM_COMMAND    - process the application menu
//  WM_PAINT    - Paint the main window
//  WM_DESTROY    - post a quit message and return
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    int wmId, wmEvent;
    PAINTSTRUCT ps;
    HDC hdc;
//	RECT rc_inv;
	int xPos; 
	int yPos;
//	width = 8;	color = 'r';
//	typedef struct tagPOINT {  LONG x;  LONG y;} POINT;

#if defined(SHELL_AYGSHELL) && !defined(WIN32_PLATFORM_WFSP)
    static SHACTIVATEINFO s_sai;
#endif // SHELL_AYGSHELL && !WIN32_PLATFORM_WFSP
    		
    switch (message) 
    {
        case WM_COMMAND:
            wmId    = LOWORD(wParam); 
            wmEvent = HIWORD(wParam); 
            // Parse the menu selections:
            switch (wmId)
            {
					
#ifndef WIN32_PLATFORM_WFSP
													
                case IDM_HELP_ABOUT:
                    DialogBox(g_hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, About);
					break;
				case ID_HELP_RED:
					color = 'r';	
					break;
				case ID_HELP_BLUE:
					color = 'b';	
					break;
				case ID_HELP_GREEN:
					color = 'g';	
					break;
				case ID_HELP_WIDER:
					width++;
					break;
				case ID_HELP_THINNER:
					width--;
					break;
				case ID_HELP_ERASE:
					color = 'w';
					width=14;
					break;
				case ID_HELP_DEFAULT:
					width = 5; color='B';
					break;
#endif // !WIN32_PLATFORM_WFSP
#ifdef WIN32_PLATFORM_WFSP
                case IDM_OK:
                    DestroyWindow(hWnd);
                    break;
#endif // WIN32_PLATFORM_WFSP
#ifndef WIN32_PLATFORM_WFSP
                case IDM_OK:
                    SendMessage (hWnd, WM_CLOSE, 0, 0);                
                    break;
#endif // !WIN32_PLATFORM_WFSP
                default:
                    return DefWindowProc(hWnd, message, wParam, lParam);
            }
			
	
            break;

        case WM_CREATE:
#ifdef SHELL_AYGSHELL
            SHMENUBARINFO mbi;
            memset(&mbi, 0, sizeof(SHMENUBARINFO));
            mbi.cbSize     = sizeof(SHMENUBARINFO);
            mbi.hwndParent = hWnd;
            mbi.nToolBarId = IDR_MENU;
            mbi.hInstRes   = g_hInst;
            if (!SHCreateMenuBar(&mbi))    g_hWndMenuBar = NULL;
            else   g_hWndMenuBar = mbi.hwndMB;
#ifndef WIN32_PLATFORM_WFSP
            // Initialize the shell activate info structure
            memset(&s_sai, 0, sizeof (s_sai));
            s_sai.cbSize = sizeof (s_sai);
#endif // !WIN32_PLATFORM_WFSP
#endif // SHELL_AYGSHELL
            break;

        case WM_PAINT:
		//	result = call_window_proc( hwnd, msg, wparam, lparam, true, true );
     //   call_sendmsg_callback( callback, hwnd, msg, data, result );
        //*GetWindowLongPtr( GWL_WNDPROC)
		//	CallWindowProc (wc.lpfnWndProc, hWnd, message, NULL, NULL);
			HPEN     hPenOld;
						
            hdc = BeginPaint(hWnd, &ps);
			if (drawing==true && max_shift>1)
			{
						if (color == 'b')		hPen = CreatePen( PS_SOLID,width, RGB(0,0,255));
						else if (color == 'r')  hPen = CreatePen( PS_SOLID,width, RGB(255,0,0));
						else if (color == 'g')  hPen = CreatePen( PS_SOLID,width, RGB(0,255,0));
						else if (color == 'w')  hPen = CreatePen( PS_SOLID,width, RGB(255,255,255));
						else if (color == 'B')  hPen = CreatePen( PS_SOLID,width, RGB(0,0,0));
						
					//hPen = ;
						//	DrawImage(hdc); INSTEAD OF THIS 
					
					hPenOld = (HPEN)SelectObject(hdc, hPen);
  						MoveToEx(hdc, FigCoorxPtr[0], FigCooryPtr[0], NULL );
				 
				
								for(int i=0; i<max_shift; i++)
									if (FigCoordPtr[i]==true)
									{
										if ((FigCoorcPtr[i]!=FigCoorcPtr[i+1]) || (FigCoorwPtr[i]!=FigCoorwPtr[i+1])) 
										{
											
										//	DeleteObject(hPen);
											if (FigCoorcPtr[i+1]=='b')		hPen = CreatePen(PS_SOLID, FigCoorwPtr[i+1], RGB(0,0,255)); 
											else if (FigCoorcPtr[i+1]=='r')	hPen = CreatePen(PS_SOLID, FigCoorwPtr[i+1], RGB(255,0,0));
											else if (FigCoorcPtr[i+1]=='g')	hPen = CreatePen(PS_SOLID, FigCoorwPtr[i+1], RGB(0,255,0));
											else if (FigCoorcPtr[i+1]=='w')	hPen = CreatePen(PS_SOLID, FigCoorwPtr[i+1], RGB(255,255,255));
											else if (FigCoorcPtr[i+1]=='B')	hPen = CreatePen(PS_SOLID, FigCoorwPtr[i+1], RGB(0,0,0));
										//	DeleteObject(hPenOld);
											hPenOld = (HPEN)SelectObject(hdc, hPen); 
										}
										LineTo(hdc, FigCoorxPtr[i], FigCooryPtr[i]);
										MoveToEx(hdc, FigCoorxPtr[i], FigCooryPtr[i],NULL );
									}
									else MoveToEx(hdc, FigCoorxPtr[i+1], FigCooryPtr[i+1],NULL );
			
			//DeleteObject(hPenOld);
			//DeleteObject(hPen);
			}
			//SelectObject(hdc, hPenOld);
			//DeleteObject(hPenOld);
			//DeleteObject(hPen); 
			EndPaint(hWnd, &ps);
            break;

        case WM_DESTROY:
#ifdef SHELL_AYGSHELL
            CommandBar_Destroy(g_hWndMenuBar);
#endif // SHELL_AYGSHELL
            PostQuitMessage(0);
            break;
#if defined(SHELL_AYGSHELL) && !defined(WIN32_PLATFORM_WFSP)

        case WM_ACTIVATE:
            // Notify shell of our activate message
            SHHandleWMActivate(hWnd, wParam, lParam, &s_sai, false);
            break;

        case WM_SETTINGCHANGE:
            SHHandleWMSettingChange(hWnd, wParam, lParam, &s_sai);
            break;
#endif // SHELL_AYGSHELL && !WIN32_PLATFORM_WFSP

        case WM_LBUTTONDOWN:
			//WM_LBUTTONDOWN fwKeys = wParam; 
			last_mouse_x = LOWORD(lParam); 
			last_mouse_y = HIWORD(lParam);
				if(max_shift==0)
				{
					max_shift=1;
					FigCoorxPtr=(int*)malloc(sizeof(int));
					FigCooryPtr=(int*)malloc(sizeof(int));
					FigCoordPtr=(bool*)malloc(sizeof(bool));
					FigCoorwPtr=(int*)malloc(sizeof(int));
					FigCoorcPtr=(char*)malloc(sizeof(char));
					//initialize the arrays
					FigCoorxPtr[0]=last_mouse_x;
					FigCooryPtr[0]=last_mouse_y;
					FigCoordPtr[0]=true;
					FigCoorwPtr[0]=width;
					FigCoorcPtr[0]='w';
					
				}
				else
				{
					max_shift++;
					FigCoorxPtr = (int*) realloc(FigCoorxPtr, max_shift*sizeof(int));
					FigCooryPtr = (int*) realloc(FigCooryPtr, max_shift*sizeof(int));
					FigCoordPtr = (bool*) realloc(FigCoordPtr, max_shift*sizeof(bool));
					FigCoorwPtr = (int*) realloc (FigCoorwPtr, max_shift*sizeof(int));
					FigCoorcPtr = (char*) realloc(FigCoorcPtr, max_shift*sizeof(char));
					FigCoorxPtr[max_shift-1]=last_mouse_x;
					FigCooryPtr[max_shift-1]=last_mouse_y;
					FigCoordPtr[max_shift-1]=false;
					FigCoorcPtr[max_shift-1]=color;
					FigCoorwPtr[max_shift-1]=width;
				}

			drawing = true;
			break;

        case WM_LBUTTONUP:
			drawing = false;
			break;

		case WM_MOUSEMOVE:
			if (drawing==true)
			{
				xPos = LOWORD(lParam); 
				yPos = HIWORD(lParam);
				shift_x = xPos - last_mouse_x;
				shift_y = yPos - last_mouse_y;
				last_mouse_x = xPos;
				last_mouse_y = yPos;
				max_shift++;
				FigCoorxPtr = (int*) realloc(FigCoorxPtr, max_shift*sizeof(int));
				FigCooryPtr = (int*) realloc(FigCooryPtr, max_shift*sizeof(int));
				FigCoordPtr = (bool*) realloc(FigCoordPtr, max_shift*sizeof(bool));
				FigCoorcPtr = (char*) realloc(FigCoorcPtr, max_shift*sizeof(char));
				FigCoorwPtr = (int*) realloc(FigCoorwPtr, max_shift*sizeof(int));
				FigCoorxPtr[max_shift-1]=xPos;
				FigCooryPtr[max_shift-1]=yPos;
				FigCoordPtr[max_shift-1]=true;
				FigCoorwPtr[max_shift-1]=width;
				FigCoorcPtr[max_shift-1]=color;
				/*
				//rc_inv = rc_img;
    			rc_img.left -= shift_x*10;
				rc_img.right -= shift_x*10;
				//rc_inv.right += shift_x;
				rc_img.top -= shift_y*10;
				rc_img.bottom -= shift_y*10;
				//rc_inv.bottom += shift_y; */
				InvalidateRect(hWnd, &rc_wnd, false);
				UpdateWindow(hWnd);
			}
			break;


        default:
            return DefWindowProc(hWnd, message, wParam, lParam);
    }
	//if (max_shift<=1)
	return 0;
}

#ifndef WIN32_PLATFORM_WFSP
// Message handler for about box.
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message)
    {
        case WM_INITDIALOG:
#ifdef SHELL_AYGSHELL
            {
                // Create a Done button and size it.  
                SHINITDLGINFO shidi;
                shidi.dwMask = SHIDIM_FLAGS;
                shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN | SHIDIF_EMPTYMENU;
                shidi.hDlg = hDlg;
                SHInitDialog(&shidi);
            }
#endif // SHELL_AYGSHELL
            return (INT_PTR)true;

        case WM_COMMAND:
#ifdef SHELL_AYGSHELL
            if (LOWORD(wParam) == IDOK)
#endif
            {
                EndDialog(hDlg, LOWORD(wParam));
                return (INT_PTR)true;
            }
            break;

        case WM_CLOSE:
            EndDialog(hDlg, message);
            return (INT_PTR)true;

#ifdef _DEVICE_RESOLUTION_AWARE
        case WM_SIZE:
            {
        DRA::RelayoutDialog(
            g_hInst, 
            hDlg, 
            DRA::GetDisplayMode() != DRA::Portrait ? MAKEINTRESOURCE(IDD_ABOUTBOX_WIDE) : MAKEINTRESOURCE(IDD_ABOUTBOX));
            }
            break;
#endif
    }
    return (INT_PTR)false;
}
#endif // !WIN32_PLATFORM_WFSP